//+--------------------------------------------------------------------------+
//|                              Based on mladen indicator TMAcentered-5.mq4 |
//+--------------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 C'45,133,84'
#property indicator_color2 C'227,86,79'
#property indicator_color3 C'45,133,84'
#property indicator_color4 clrDimGray
#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 3
#property indicator_width4 3

extern int   HalfLengthFastTMA = 5;
extern int   HalfLengthSlowTMA = 11;
extern bool  FillRibbon        = true;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double prices[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(5);
      HalfLengthFastTMA=MathMax(HalfLengthFastTMA,1);
      HalfLengthSlowTMA=MathMax(HalfLengthSlowTMA,1);
      if (FillRibbon)
      {
         SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM); //SetIndexDrawBegin(2,HalfLengthFastTMA);
         SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM); //SetIndexDrawBegin(3,HalfLengthFastTMA);
      }
      SetIndexBuffer(3,buffer1);
      SetIndexBuffer(2,buffer2);
      SetIndexBuffer(4,prices);
      return(0);
}
int deinit() { return(0); }
int start()
{

   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,MathMax(HalfLengthFastTMA,HalfLengthSlowTMA)),Bars-1);

   for (int i=limit; i>=0; i--) prices[i] = Open[i];
   for (    i=limit; i>=0; i--)
   {
      buffer1[i] = icTma(HalfLengthFastTMA,i); buffer3[i] = buffer1[i];
      buffer2[i] = icTma(HalfLengthSlowTMA,i); buffer4[i] = buffer2[i];
   }
   return(0);
}

//
//
//
//
//

double icTma(int period, int i)
{
   double sum  = (period+1)*prices[i];
   double sumw = (period+1);

      //
      //
      //
      //
      //
      
      for(int j=1, k=period; j<period; j++,k--)
      {
         sum  += prices[i+j]*k;
         sumw += k;
         if (j<=i)
         {
               sum  += prices[i-j]*k;
               sumw += k;
         }
      }
   return(sum/sumw);
}